/************************************************************
    Program:  CreateXref.p
     Author:  Tim Townsend
    Created:  28 Sep 1999
Description:  create xref from within Ed4W

************************************************************/

def var cFile                as char                       no-undo.
def var cXrfFile             as char                       no-undo.
def var cErrFile             as char                       no-undo.
def var cErrMsg              as char                       no-undo.
def var cEd4WPath            as char                       no-undo.
def var i                    as int                        no-undo.
def var lCompileOnSave       as log   init false           no-undo.
def var iSourceLine          as int                        no-undo.
def var iXrefLine            as int                        no-undo.

def stream sErrs.
def stream sXref.

def frame fDDE with no-box no-labels.

pause 0 before-hide.

/* Create aliases */
if num-dbs > 0 then do:
  create alias dictdb2 for database value(ldbname(1)).
  create alias icdata for database value(ldbname(1)).
  create alias ardata for database value(ldbname(1)).
  create alias apdata for database value(ldbname(1)).
  create alias sodata for database value(ldbname(1)).
  create alias podata for database value(ldbname(1)).
  create alias sadata for database value(ldbname(1)).
  create alias smdata for database value(ldbname(1)).
end.  /* if */

assign
  cFile       = entry(1,session:parameter)
  cEd4WPath   = entry(2,session:parameter) + "\ed32.exe"
  cXrfFile    = substr(cFile,1,r-index(cFile,".")) + "xrf"
  iSourceLine = int(entry(3,session:parameter)) no-error.

if cFile > "" then
do:
  compile value(cFile)
    xref value(cXrfFile).

  if search(cXrfFile) <> ? then do:
    if iSourceLine > 0 then
      run FindXrefLine(iSourceLine, output iXrefLine).

    run WinExec(cEd4WPath + " " + cXrfFile + " -1 -l " + string(iXrefLine),1).

  end.  /* if */
end.  /* if */

if program-name(2) = ? then
  quit.

/****************************************************************************/
procedure WinExec external "kernel32" :
  define input  parameter lpszcmdline as char.
  define input  parameter fucmdshow   as long.
end procedure.

/****************************************************************************/
procedure FindXrefLine:
def input        param iSourceLine          as int         no-undo.
def       output param iXrefLine            as int         no-undo.

def var cSource              as char                       no-undo.
def var cInclude             as char                       no-undo.
def var cType                as char                       no-undo.
def var iLine                as int                        no-undo.

  assign iXrefLine = 0.

  input stream sXref from value(cXrfFile).

  ReadLoop:
  repeat:
    iLine = 0.
    import stream sXref
      cSource cInclude iLine cType.
    assign iXrefLine = iXrefLine + 1.
    if cSource = cFile and cInclude = cFile and iLine >= iSourceLine then
      leave ReadLoop.
  end.  /* repeat */

  input stream sXref close.

  return.
end procedure. /* ? */
